import "pkl:math"

class Banana {
  isRipe: Boolean
}

class Grape {
  isUsedForWine: Boolean
}

class Apple {
  isRed: Boolean
}

abstract class Animal {
  name: String
}

typealias Fruit = Banana | Grape | Apple

typealias City = "San Francisco"|"Tokyo"|"Zurich"|"London"

abstract class Shape

class Square extends Shape {
  fixed corners: Int = 4
}

fruit1: Fruit = new Banana {
  isRipe = true
}

fruit2: Fruit = new Grape {
  isUsedForWine = true
}

fruit3: Fruit = new Apple {
  isRed = false
}

city1: City = "San Francisco"

city2: City = "Tokyo"

city3: City = "Zurich"

city4: City = "London"

class Zebra extends Animal { name = "Zebra" }

class Donkey extends Animal { name = "Donkey" }

typealias ZebraOrDonkey = Zebra|Donkey

animal1: ZebraOrDonkey = new Zebra {}

animal2: ZebraOrDonkey = new Donkey {}

typealias AnimalOrString = Animal|String

animalOrString1: AnimalOrString = new Zebra {}

animalOrString2: AnimalOrString = "Zebra"

typealias IntOrFloat = Int | Float

intOrFloat1: IntOrFloat = 5.0

intOrFloat2: IntOrFloat = 5.5

intOrFloat3: IntOrFloat = 128

typealias Environment = "dev"|"prod"|"qa"

config: Mapping<Environment, String> = new {
  ["dev"] = "Imaginary Service Company (ISC) configuration"
}

typealias AnimalOrShape = Animal|Shape

animalOrShape1: AnimalOrShape = new Donkey {}

animalOrShape2: AnimalOrShape = new Square {}

typealias Numbers = Int8 | Int16 | Int32 | Int

numbers1: Numbers = 5

numbers2: Numbers = 128

numbers3: Numbers = 32768

numbers4: Numbers = math.maxInt
