//===----------------------------------------------------------------------===//
// Copyright © 2024-2025 Apple Inc. and the Pkl project authors. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//===----------------------------------------------------------------------===//

@Unlisted
module pkl.swift.internal.TypeAliasGen

extends "Gen.pkl"

import "typegen.pkl"
import "Type.pkl"
import "pkl:reflect"

typealiaz: reflect.TypeAlias = mapping.source as reflect.TypeAlias

type: Type = typegen.generateType(typealiaz.referent, typealiaz, mappings)

contents = "public typealias \(mapping.name) = \(type.render(namespaceName))"
